﻿using System;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Security.AccessControl;
using System.Security.Principal;
using System.Threading;
using System.Windows.Forms;

namespace RCM {
    static class Program {
        [STAThread]
        static void Main() {
            Application.EnableVisualStyles();
            Application.SetCompatibleTextRenderingDefault(false);

            string appGuid = ((GuidAttribute)Assembly.GetExecutingAssembly().GetCustomAttributes(typeof(GuidAttribute), false).GetValue(0)).Value.ToString();
            string mutexId = string.Format("Local\\{{{0}}}", appGuid);

            using (Mutex mutex = new Mutex(false, mutexId)) {
                bool hasHandle = false;
                try {
                    try {
                        hasHandle = mutex.WaitOne(0, false);
                        if (hasHandle == false) {
                            MessageBox.Show("An instance of the application is already running", "Information", MessageBoxButtons.OK, MessageBoxIcon.Information);
                            return;
                        }
                    } catch (AbandonedMutexException) {
                        hasHandle = true;
                    }
                    Config.LoadModules();
                    Config.LoadConfiguration();
                    Application.Run(new MainForm());
                } finally {
                    if (hasHandle) {
                        mutex.ReleaseMutex();
                    }
                }
            }
        }
    }
}
