﻿using System;
using System.Diagnostics;
using System.Threading.Tasks;

namespace RCM {
    [DisplayName("Open in browser")]
    public class BrowserAction : IAction {
        private WebSite _website;

        public BrowserAction(WebSite website) {
            _website = website;
        }

        public async void Run() {
            await Task.Run(() => {
                if (_website.URL.StartsWith("http://") || _website.URL.StartsWith("https://")) {
                    if (Environment.OSVersion.Platform == PlatformID.Unix) {
                        Process.Start("xdg-open", _website.URL);
                    } else {
                        Process.Start(_website.URL); // TODO: vyplnovat hesla
                    }
                }
            });
        }
    }
}
