﻿using System.Collections;
using System.Windows.Forms;

namespace RCM {
    public class RecordNodeSorter : IComparer {
        public int Compare(object o1, object o2) {
            IRecord record1 = (IRecord)((TreeNode)o1).Tag;
            IRecord record2 = (IRecord)((TreeNode)o2).Tag;

            int result;

            if (record1 is Group) {
                if (record2 is Group) {
                    result = string.Compare(record1.Title, record2.Title);
                    if (result == 0) {
                        result = string.Compare(record1.Id.ToString(), record2.Id.ToString());
                    }
                } else {
                    result = -1;
                }
            } else if (record2 is Group) {
                result = 1;
            } else {
                result = string.Compare(record1.Title, record2.Title);
                if (result == 0) {
                    result = string.Compare(record1.Id.ToString(), record2.Id.ToString());
                }
            }
            return result;
        }
    }
}
