﻿/*using Microsoft.VisualBasic.FileIO;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace RCM {
    public static class Importer {
        public static List<IRecord> GetRecordsFromRDM() {
            Dictionary<string, Guid> groups = new Dictionary<string, Guid>();
            List<IRecord> records = new List<IRecord>();
            string previousGroup = null;

            using (TextFieldParser parser = new TextFieldParser("EntryList.csv", Encoding.UTF8)) {
                parser.TextFieldType = FieldType.Delimited;
                parser.SetDelimiters(",");
                parser.ReadFields(); // Skip headers
                while (!parser.EndOfData) {
                    string[] fields = parser.ReadFields();
                    string type = fields[0];
                    string name = fields[3];
                    string group = fields[4];
                    string parent = fields[7];
                    string host = fields[8];
                    string port = fields[9];
                    string username = fields[10];
                    string domain = fields[11];
                    string password = fields[12];
                    string url = fields[14];

                    if (!string.IsNullOrWhiteSpace(parent)) {
                        // Naive identification of subconnections ownership
                        group = previousGroup;
                    }
                    if (!string.IsNullOrWhiteSpace(port)) {
                        host = string.Format("{0}:{1}", host, port);
                    }
                    if (!string.IsNullOrWhiteSpace(domain)) {
                        username = string.Format("{0}\\{1}", domain, username);
                    }

                    IRecord record = null;
                    if (type == "Folder" || type == "Site") {
                        string[] splitGroup = group.Split("\\".ToCharArray());
                        group = string.Join("\\", splitGroup.Take(splitGroup.Length - 1));
                    } else if (type == "Winbox") {
                        record = new WinBox() { Id = Guid.NewGuid(), Title = name, Host = host, Username = username, Password = password };
                    } else if (type == "Microsoft Remote Desktop (RDP)") {
                        record = new RDP() { Id = Guid.NewGuid(), Title = name, Host = host, Username = username, Password = password };
                    } else if (type == "Putty") {
                        record = new SSH() { Id = Guid.NewGuid(), Title = name, Host = host, Username = username, Password = password };
                    } else if (type == "Web Browser (http/https)") {
                        record = new WebSite() { Id = Guid.NewGuid(), Title = name, URL = url, Username = username, Password = password };
                    } else if (type == "FTP (Third Party)") {
                        // skip
                    } else {
                        MessageBox.Show(string.Format("Type: {0}, Title: {1}", type, name));
                    }
                    if (record != null) {
                        string[] splitGroup = group.Split("\\".ToCharArray());
                        for (int i = 0; i < splitGroup.Length; i++) {
                            string level = string.Join("\\", splitGroup.Take(i+1));
                            if (!groups.ContainsKey(level)) {
                                Group g = new Group() { Id = Guid.NewGuid(), Title = splitGroup[i], GroupId = i == 0 ? Guid.Empty : groups[string.Join("\\", splitGroup.Take(i))] };
                                records.Add(g);
                                groups.Add(level, g.Id);
                            }
                        }
                        record.GroupId = groups[group];
                        records.Add(record);
                    }
                    previousGroup = group;
                }
            }

            return records;
        }
    }
}
*/